/*
Copyright (C) 2006 Evan Teran
                   eteran@alum.rit.edu

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef ELF64_20070718_H_
#define ELF64_20070718_H_

#include "BinaryInfo.h"
#include <elf.h>

class ELF64 : public BinaryInfo {
public:
	ELF64(const QString &filename);
	virtual ~ELF64();

public:
	virtual bool validateHeader();
	virtual edb::address_t getEntryPoint();
	virtual bool nativeBinary();

private:
	void readHeader();
	
private:
	Elf64_Ehdr *m_Header;
};

#endif

